<?php
/*
** Admin Related Functions Here...
*/

/* 
**============= Direct Access Not Allowed ================ 
*/
if( ! defined('ABSPATH' ) ){ exit; }

add_action('wp_ajax_postis_show_shipment', 'postis_show_shipment');

add_action('wp_ajax_postis_shipment_options', 'postis_shipment_options');
add_action('wp_ajax_postis_phonenumber_invalid', 'postis_phonenumber_invalid');

// create shipment
add_action('wp_ajax_postis_create_shipment_action', 'postis_create_shipment_action');

add_action( 'admin_post_postis_pdf_action', 'postis_pdf_action' );

// Delete shipment and create again
add_action( 'admin_post_postis_delete_shipment', 'postis_delete_shipment' );

add_action( 'admin_notices', 'postis_admin_show_notices' );

add_action( 'admin_enqueue_scripts', 'postis_queue_my_admin_scripts');

// Show metaboxe on order template
add_action( 'admin_init', 'postis_create_order_metabox');

// Admin file enque hook
add_action('admin_enqueue_scripts', 'load_script');

function load_script($hook){
			
// 	postis_pa($_GET['page']); exit;

    if( ! isset($_GET['page']) || $_GET['page'] != "wc-settings") return;

    wp_enqueue_script( 'postis-wc-sortable', POSTIS_URL.'/js/postis-admin-wc.js', array('jquery','jquery-ui-core', 'jquery-ui-sortable'),  1.0, true);
}


function postis_create_order_metabox() {
    
    add_meta_box( 'postis_order_shipment', 
                __('Postis Shipment', 'postis'),
                'postis_display_shipment_metabox',
                'shop_order', 
                'side', 
                'default'
            );
}

function postis_display_shipment_metabox($order){
    
    
    // Enqueu files
    $postis_vars_array = array( 'ajaxurl' => admin_url( 'admin-ajax.php', (is_ssl() ? 'https' : 'http') ), 'loader' => POSTIS_URL.'/images/loader.gif', );
							
    add_thickbox();
    wp_enqueue_style('postis-admin-css', POSTIS_URL."/css/postis-admin-order.css");
    wp_enqueue_script('postis-admin-js', POSTIS_URL."/js/postis-admin-order.js", array('jquery'), 1.0, true);
    
    wp_localize_script( 'postis-admin-js', 'postis_order_vars', $postis_vars_array);
    
    // Get order ID
    $order_id = $order->ID;
    
    $admin_url = admin_url('admin-post.php');
	$pdf_url   = add_query_arg(array('action'=>'postis_pdf_action','order_id'=> $order_id), $admin_url);
	
	
    // Getting Shipment Detail
	$get_shipment_meta = postis_get_shipment_data($order_id, 'shipmentId');
	$shipment_status   = is_shipment_ready($order_id);
    $sender_meta       = postis_get_shipment_data($order_id, 'recipient');
    $country_code      = isset($sender_meta['countryCode']) ? $sender_meta['countryCode'] : '';
    
    // Check if shipment is international
    $is_shipment_international = postis_is_shipment_international($country_code);
    
    $open_pdf_newtab         = postis_get_settings( 'open_pdf_newtab' );
    $open_pdf_status = '_self';
    if ($open_pdf_newtab == 'yes') {
        $open_pdf_status = '_blank';
    }

    // Check Shipment Ready and Create or View
    if ($shipment_status == true) {
        
        if ($get_shipment_meta != '') {
            echo '<a class="postis-view-shipment-js button button-primary" href="#" data-order-id="'.esc_attr($order_id).'">'.__("View Shipment", "postis"). '</a>';
        }else{
            echo '<a class="button button-primary postis-shipment-options-js" href="#" data-order-id="'.esc_attr($order_id).'">'. __("Create Shipment", "postis").'</a>';
        }
    }else{
        echo __("Shipment Available After Order Completed", "postis");
    }
            
    // Get Created Shipment PDF
    if ($shipment_status == true && $get_shipment_meta != '') {
        echo '<br><br><a class="button button-primary" href="'.esc_url($pdf_url).'" target="'.esc_attr($open_pdf_status).'">'. __("Get PDF", "postis").'</a>';
    }

}

function postis_shipment_options(){
	
	
	$vars = array( 'order_id'  => intval( $_REQUEST['order_id'] ) );

	postis_load_template( 'shipment-options.php', $vars);
	
	die(0);
}

// function postis_phonenumber_invalid(){
	
// 	echo 'add phone number';
// // 	$vars = array( 'order_id'  => intval( $_REQUEST['order_id'] ) );
        
// // 	postis_load_template( 'shipment-options.php', $vars);
	
// 	die(0);
// }


function postis_delete_shipment(){
	
	$order_id = isset( $_REQUEST['order_id'] ) ? intval( $_REQUEST['order_id'] ) : 0;

	update_post_meta( $order_id, 'postis_shipment_meta', array() );
	
	$wc_shoporder_url = admin_url('edit.php?post_type=shop_order');
	wp_redirect($wc_shoporder_url);
	die(0);
}

function postis_show_shipment(){
	
	$endpoint_url = postis_get_endpoints( 'tracking' );
	
	$shipmentId =  postis_get_shipment_data(intval( $_REQUEST['order_id'] ), 'shipmentId');
	
	// Request params.
    $params = array(
        'trackingNumber' => $shipmentId,
        'language' => 'IS',
    );
    
    $params = array_filter( $params );
    $domain	= $_SERVER['HTTP_HOST'];
    
    // Query format parameters.
    $query = add_query_arg( $params, $endpoint_url );
    
    $req_headers = array("headers" => array('domain_name'=> $domain));
    
    $response = wp_remote_get( $query, $req_headers );
    
    $tracking_info = json_decode( $response['body'], true );
    // postis_pa($tracking_info); exit;
    
	
	$vars = array( 'order_id'  => intval( $_REQUEST['order_id'] ), 'tracking'=> $tracking_info );

	postis_load_template( 'shipment-view.php', $vars);
	
	die(0);
}

function postis_queue_my_admin_scripts($hook) {
    
    global $post;
    
    if( ( $hook != 'edit.php' ) || ( isset($post->post_type) && $post->post_type != 'shop_order') ) return '';
    
    $postis_vars_array = array( 'ajaxurl' => admin_url( 'admin-ajax.php', (is_ssl() ? 'https' : 'http') ), 'loader' => POSTIS_URL.'/images/loader.gif', );
							
    add_thickbox();
    
    wp_enqueue_style('postis-admin-css', POSTIS_URL."/css/postis-admin-order.css");
    wp_enqueue_script('postis-admin-js', POSTIS_URL."/js/postis-admin-order.js", array('jquery'), 1.0, true);
    
    wp_localize_script( 'postis-admin-js', 'postis_order_vars', $postis_vars_array);
}


function postis_admin_show_notices() {

    $class   = '';
    $message = '';
    if( isset($_GET['status']) && $_GET['status'] == 'shipment_created') {
        
        $class = 'notice notice-success';
        $message = __( 'Shipment Created Successfully' );
    } elseif(isset($_GET['status']) && $_GET['status'] == 'shipment_error') {
        
        $class = 'notice notice-error';
        $message = __( 'Shipment Not Created' );
    }

    printf( '<div class="%1$s"><p>%2$s</p></div>', esc_attr( $class ), esc_html( $message ) ); 
}


function postis_create_shipment_action() {
    
    $order_id   = isset($_REQUEST['order_id']) ? intval($_REQUEST['order_id']) : 0;
    
    $numberofitems   = isset($_REQUEST['numberofitems']) ? intval($_REQUEST['numberofitems']) : '';
    $shipmnet_desc   = isset($_REQUEST['description']) ? sanitize_text_field($_REQUEST['description']) : '';
    
   
    // Get Dynamic Options
    $dynamic_opt_control        = array();
    if(isset($_REQUEST['optional_services']) && is_array($_REQUEST['optional_services'])){
		$dynamic_shipment_options = array_map('sanitize_text_field', $_REQUEST['optional_services']);
	}
	
    // 	For international shipment
    $new_contents_meta = array();
	if(isset($_REQUEST['contents']) && is_array($_REQUEST['contents'])){
	    foreach ($_REQUEST['contents'] as $item_id => $contents_meta) {
	        
		    $new_contents_meta[$item_id] = array_map('sanitize_text_field', $contents_meta);
	    }
	}
// 	postis_pa($new_contents_meta); exit;


    foreach($dynamic_shipment_options as $opt_name => $opt_val){
        if ( isset($dynamic_shipment_options[$opt_name]) && $dynamic_shipment_options[$opt_name] == 'on' ) {
            $dynamic_opt_control[$opt_name] = true;       
        }else{
            $dynamic_opt_control[$opt_name] = $opt_val;       
        }
    }
    
    
    // Get order meta
    $order = wc_get_order($order_id);
    
    // User's Shipping data
    $ship_methods          = $order->get_shipping_methods(); 
    $shipping_customerName = $order->get_formatted_shipping_full_name();
    $shipping_address1     = $order->get_shipping_address_1();
    $shipping_postcode     = $order->get_shipping_postcode();
    $country_code          = $order->get_shipping_country();
    $city                  = $order->get_shipping_city();
    $customer_email        = $order->get_billing_email();
    $customer_phone        = $order->get_billing_phone();
    
    $valid_phonenumber   = isset($_REQUEST['phonenumber']) && $_REQUEST['phonenumber'] != '' ? wc_sanitize_phone_number( $_REQUEST['phonenumber'] ): $customer_phone;
    //  var_dump($valid_phonenumber); exit;
    
    
     if ( isset($dynamic_opt_control['cod']) && $dynamic_opt_control['cod'] ) {
        $order_total = $order->get_total();
        $dynamic_opt_control['codAmount'] = $order_total;
    }
    

    //if ( $shipmnet_desc != '' ) {
        $shipmnet_desc = sprintf(__("W: %s", "postis"), $shipmnet_desc);
    //}
    
    
    
    // Get Shipping Method
    $shipping_service      = get_post_meta( $order_id, 'postis_shipping_method', true );
    
    // Get Create Shipment Endpoint
    $endpoint_url = postis_get_endpoints( 'create_shipment' );
    
    // Get Apikey
    $postis_apikey = postis_get_settings( 'apikey' );
    $domain	= $_SERVER['HTTP_HOST'];
    
    // If Service is DPO add postboxes address
    if ($shipping_service == 'DPO') {
        
        
        // Get All Postbox List From API
        $postbox_endpoint_url = postis_get_endpoints( 'postboxes' );
        $req_headers          = array("headers" => array('x-api-key'=>$postis_apikey,'domain_name'=> $domain));
        $postbox_response     = wp_remote_get( $postbox_endpoint_url, $req_headers );
        $postbox_list         = json_decode( wp_remote_retrieve_body($postbox_response), true);
        
        $postbox_id          = get_post_meta( $order_id, 'postis_dpo_postbox', true );
        $postbox_phonenumber = get_post_meta( $order_id, 'postis_dpo_phonenumber', true );
        
        $postbox_phonenumber   = isset($_REQUEST['phonenumber']) && $_REQUEST['phonenumber'] != '' ? wc_sanitize_phone_number( $_REQUEST['phonenumber'] ): $postbox_phonenumber;
        
        // postis_pa($postbox_list); exit;
        if( ! is_wp_error($postbox_response) && $postbox_response['response']['code'] == 200 ) {
            foreach ($postbox_list['postboxes'] as $index => $postboxes) {
                
                if ($postboxes['postboxId'] == $postbox_id) {
                    
                    $postboxes_address = sprintf(__("Póstbox %s", "postis"), $postboxes['address']);
                    
                    $recipeint = array( 'name'         => $shipping_customerName,
                                        'addressLine1' => $postboxes_address,
                                        "postcode"     => $postboxes['postcode'],
                                        "countryCode"  => $country_code,
                                        "mobilePhone"  => $postbox_phonenumber,
                        );          
                }
            }
        }
        
    }else{
        if ($shipping_service == 'DPP' OR $shipping_service == 'DPH') {
            if (substr($customer_phone, 0, 1) === '6' || substr($customer_phone, 0, 1) === '7' || substr($customer_phone, 0, 1) === '8') {
                // phoneNumber is valid
            } else {
                $valid_phonenumber = '';
            }
        }
        $recipeint = array( 'name'         => $shipping_customerName,
                            'addressLine1' => $shipping_address1,
                            "postcode"     => $shipping_postcode,
                            "countryCode"  => $country_code,
                            "mobilePhone"  => $valid_phonenumber,
                        );
    }
                    
    // If Shipment is international
    $international_shipment = postis_is_shipment_international($country_code);
    
    if ($international_shipment) {
        $recipeint['town']  =  $city;
    }
    $recipeint['email'] =  $customer_email;
    //$recipeint['mobilePhone'] =  $customer_phone;
    
    
    
    $options      = array('deliveryServiceId' => $shipping_service, 'numberOfItems' => floatval($numberofitems), 'description' => $shipmnet_desc);
    $option_array = array_merge($options, $dynamic_opt_control);
    
    // Request params.
    if ($international_shipment) {
        
        // $contents_for_inter = (object) $contents_for_inter;
        
        $params = array(
    	        'recipient'                => $recipeint,
    	        'options'                  => $option_array,
    	        'contents'                 => $new_contents_meta,
    	    );
    }else{
        $params = array(
    	        'recipient'                => $recipeint,
    	        'options'                  => $option_array,
    	    );
    }
    
    //  postis_pa($contents_for_inter); exit;
    
    // Remove empty parameters (eg.: to and from).
    $params = array_filter( $params );
    
    // postis_pa($params); exit;
    
    // Set Header
	$headers = array(
            'headers'     => array('Content-Type' => 'application/json; charset=utf-8', 'x-api-key'=>$postis_apikey,'domain_name'=> $domain),
            'body'        => json_encode($params),
            'method'      => 'POST',
            'data_format' => 'body',
        );
		    
    // Run the query
    $response = wp_remote_post( $endpoint_url, $headers );
    $get_shipment_meta = json_decode( $response['body'], true );
    // postis_pa($get_shipment_meta); exit;
    if(  $response['response']['code'] != 400 && $response['response']['code'] != 401 ) {
        
        update_post_meta( $order_id, 'postis_shipment_meta', $get_shipment_meta );
        
        $ajax_response = array('status'=>'success', 'message'=> __('Shipment Created Successfully', 'postis'));
        
    }else{
        $resp_message  = sprintf( __("Shipment Not Created.\nServer Response: %s", "postis"), $get_shipment_meta['message'] );
        
        if (strpos($get_shipment_meta['message'], 'Ekki var hægt að skrá sendingu (Addressee.Gsm') !== false) {
            $ajax_response = array('status'=>'error', 'type'=>'phonenumber', 'message'=> $resp_message );
        } else {
            $ajax_response = array('status'=>'error', 'type'=>'other', 'message'=> $resp_message );
        }
        
    }
    
    wp_send_json( $ajax_response );
}


function postis_pdf_action() {
    
    $order_id   = isset($_REQUEST['order_id']) ? intval($_REQUEST['order_id']) : 0;
    
    $domain	= $_SERVER['HTTP_HOST'];
    
    $customerId         =  postis_get_shipment_data($order_id, 'customerId');
    $registrationKey    =  postis_get_shipment_data($order_id, 'registrationKey');
    $shipmentId         =  postis_get_shipment_data($order_id, 'shipmentId');
    
    // check if shipment is international STOP here
    $sender_meta = postis_get_shipment_data($order_id, 'recipient');
    $options_meta = postis_get_shipment_data($order_id, 'options');
    $numberofitems = !empty($options_meta['numberOfItems']) ? $options_meta['numberOfItems'] : 1;
    $country_code = isset($sender_meta['countryCode']) ? $sender_meta['countryCode'] : '';
    $is_shipment_international = postis_is_shipment_international($country_code);
    
    // Get pdf settings
    $pdf_width         = postis_get_settings( 'pdf_width' );
    $pdf_height        = postis_get_settings( 'pdf_height' );
    $pdf_rotate        = postis_get_settings( 'pdf_rotate' );
    $pdf_orientation   = postis_get_settings( 'pdf_orientation' );
    $pdf_moveright     = postis_get_settings( 'pdf_moveright' );
    $pdf_movedown      = postis_get_settings( 'pdf_movedown' );
    $pdf_biggerbarcode = postis_get_settings( 'pdf_biggerbarcode' );
    
    // Get Apikey
    $postis_apikey = postis_get_settings( 'apikey' );
    
    // PDF Endpoint
    $pdf_endpoint = postis_get_endpoints( 'pdf' ).$shipmentId.'/pdf';
    
    // Print Process
    $print_endpoint = postis_get_endpoints( 'print' );
    $print_params = array(
        'shipmentId' => $shipmentId,
        'outputFormat'      => 'poststod'
    );
    $print_params = array_filter( $print_params );
    
    
    // Query format parameters.
    $print_query = add_query_arg( $print_params, $print_endpoint );
    
    // Set Header
	$print_headers = array(
            'headers'     => array('x-api-key'=>$postis_apikey, 'domain_name'=> $domain),
            //'body'        => json_encode($print_params),
            'method'      => 'POST',
            // 'data_format' => 'body',
        );
    // postis_pa($print_headers);   
		    
    // Run the query
    $automatic_printing = postis_get_settings( 'pdf_print' );
    if ($automatic_printing == 'yes') {
        $print_response = wp_remote_post( $print_query, $print_headers );
        
        $print_response_code = wp_remote_retrieve_response_code( $print_response );
        
        if ($print_response_code == 204 ) {
            update_post_meta( $order_id, 'postis_is_shipment_printed', 'printed' );
        }else{
            update_post_meta( $order_id, 'postis_is_shipment_printed', 'not_printed' );
        }
    }
    
    // postis_pa($print_response_code); exit;
    
    
    $params = array(
        'registrationKey' => $registrationKey,
        'customerId'      => $customerId,
        'inline'          => 'true'
    );
    $params = array_filter( $params );
    
    // Query format parameters.
    $query = add_query_arg( $params, $pdf_endpoint );


    $pdf_request = wp_remote_get( $query ,
                        array( 
                            'timeout' => 10,
                            'headers' => array( 
                                'accept'=>'application/pdf',
                                'content-type'=>'application/pdf',
                                'x-api-key'=>$postis_apikey,
                                'domain_name'=> $domain
                            ) 
                        )
                    );

    if ( is_wp_error( $pdf_request ) || wp_remote_retrieve_response_code( $pdf_request ) != 200 ) {
        echo wp_remote_retrieve_body( $pdf_request );
    } else {

        $response = wp_remote_retrieve_body( $pdf_request );
        // save PDF
        postis_generate_pdf( $response, $shipmentId );
        
        $pdf_name = "{$shipmentId}.pdf";
        
        $pdf_args = array(  'pdf_width'         => $pdf_width,
                            'pdf_height'        => $pdf_height,
                            'pdf_rotate'        => $pdf_rotate,
                            'pdf_orientation'   => $pdf_orientation,
                            'pdf_moveright'     => $pdf_moveright,
                            'pdf_movedown'      => $pdf_movedown,
                            'pdf_biggerbarcode' => $pdf_biggerbarcode,
                            'numberOfItems' => $numberofitems,
                            );
                            
        postis_process_pdf( $pdf_name, $pdf_args, $is_shipment_international);
        header("Content-type: application/pdf");
        header("Content-disposition: inline;filename=".$pdf_name);
        
        exit;
    }
}

function postis_generate_pdf( $response, $shipment_id ) {
    
    $path_pdf   = postis_files_setup_get_directory('pdf')."/{$shipment_id}.pdf";
    $pdf_fp     = fopen($path_pdf, 'w');
    
    fwrite($pdf_fp, $response);
    fclose($pdf_fp);
}


add_filter( 'manage_edit-shop_order_columns', 'postis_admin_shop_order_column',20);
add_filter( 'manage_shop_order_posts_custom_column', 'postis_admin_shop_order_column_data', 20, 2 );

function postis_admin_shop_order_column($columns) {
	
    $columns['shipment_column'] = __( 'Shipment', 'postis' );
    $columns['pdf_column'] = __( 'PDF', 'postis' );

    return $columns;
}

function postis_admin_shop_order_column_data( $column, $order_id ) {

	$admin_url = admin_url('admin-post.php');
	$pdf_url   = add_query_arg(array('action'=>'postis_pdf_action','order_id'=> $order_id), $admin_url);
	
	$get_shipment_meta = postis_get_shipment_data($order_id, 'shipmentId');
	
	$shipment_status = is_shipment_ready($order_id);
	
    $sender_meta = postis_get_shipment_data($order_id, 'recipient');
    //postis_pa($sender_meta);
    $country_code = isset($sender_meta['countryCode']) ? $sender_meta['countryCode'] : '';
    
    // check if shipment is international
    $is_shipment_international = postis_is_shipment_international($country_code);
    
    // PDF Settings
    $open_pdf_newtab         = postis_get_settings( 'open_pdf_newtab' );
    $open_pdf_status = '_self';
    if ($open_pdf_newtab == 'yes') {
        $open_pdf_status = '_blank';
    }
    
    switch ( $column ) {

        case 'shipment_column' :
            
            if ($shipment_status == true) {
                
                if ($get_shipment_meta != '') {
                    echo '<a class="postis-view-shipment-js button button-primary" href="#" data-order-id="'.esc_attr($order_id).'">'.__("View Shipment", "postis"). '</a>';
                }else{
                    echo '<a class="button button-primary postis-shipment-options-js" href="#" data-order-id="'.esc_attr($order_id).'">'. __("Create Shipment", "postis").'</a>';
                }
            }else{
                echo '--';
            }
            break;

        case 'pdf_column' :
            
            if ($shipment_status == true && $get_shipment_meta != '') {
                
                $print_status = get_post_meta( $order_id, 'postis_is_shipment_printed', true );
                
                if ($print_status == 'printed') {
                    $tooltip = __('Shipment Printed', 'postis');
                    $icon = '<span data-tip="'.esc_attr($tooltip).'" class="tips dashicons dashicons-yes" style="color:#00ff00;margin-top: 4px;"></span>';
                }else{
                    $icon = '';
                }
                
                echo '<a class="button button-primary" href="'.esc_url($pdf_url).'" target="'.esc_attr($open_pdf_status).'">'. __("Get PDF", "postis"). $icon .'</a>';
            }else{
                echo '--';
            }
            break;
    }
}


// function postis_get_shipment_data($order_id, $shipmet_key){
    
//     $shipment_meta = get_post_meta($order_id, 'postis_shipment_meta', true );
     
//     $postval       = isset($shipment_meta[$shipmet_key]) ? $shipment_meta[$shipmet_key] : '';
    
//     return $postval;
// }

add_action( 'woocommerce_product_options_shipping', 'postis_product_custom_field' );

function postis_product_custom_field () {
    global $woocommerce, $post;
    echo '<div class="options_group">';
        woocommerce_wp_text_input( 
            array( 
                'id'          => 'hsTariffNumber', 
                'label'       => __( 'Tarriff Number', 'postis' ), 
                'placeholder' => '',
                'desc_tip'    => 'true',
                'description' => __( 'Tarriff Number. Needs to be 6 or 8 numbers', 'postis' ) 
            )
        );
        woocommerce_wp_text_input( 
            array( 
                'id'          => 'descriptionOfContents', 
                'label'       => __( 'Description in english', 'postis' ), 
                'placeholder' => '',
                'desc_tip'    => 'true',
                'description' => __( 'This needs to be written in english!', 'postis' ) 
            )
        );
    echo '</div>';
}
    
add_action('woocommerce_process_product_meta', 'postis_save_product_field' );

function postis_save_product_field($post_id) {

    $hsnumber     = isset($_POST['hsTariffNumber']) ? $_POST['hsTariffNumber'] : '';
    $descContents = isset($_POST['descriptionOfContents']) ? $_POST['descriptionOfContents'] : '';

    update_post_meta($post_id, 'hsTariffNumber', sanitize_text_field($hsnumber));
    update_post_meta($post_id, 'descriptionOfContents', sanitize_text_field($descContents));
}

add_filter( 'bulk_actions-edit-shop_order', 'postis_order_bulk_action_option', 20, 1 );
function postis_order_bulk_action_option( $actions ) {
    $actions['create_shipment'] = __( 'CreateShipment', 'postis' );
    $actions['print_shipment'] = __( 'PrintShipments', 'postis' );
    return $actions;
}

add_filter( 'handle_bulk_actions-edit-shop_order', 'postis_bulk_action_process', 10, 3 );
function postis_bulk_action_process( $redirect_to, $action, $post_ids ) {
    // if ( $action !== 'create_shipment' || $action !== 'print_shipment')
    //     return $redirect_to;

    $processed_ids = array();
    $recipeint = array();
    
    $postis_apikey = postis_get_settings( 'apikey' );
    $domain	= $_SERVER['HTTP_HOST'];
    $endpoint_url = postis_get_endpoints( 'create_shipment' );
    
    if ($action === 'create_shipment') {
        
        foreach ( $post_ids as $post_id ) {
            
            $order = wc_get_order( $post_id );
            $ship_methods          = $order->get_shipping_methods(); 
            $shipping_customerName = $order->get_formatted_shipping_full_name();
            $shipping_address1     = $order->get_shipping_address_1();
            $shipping_postcode     = $order->get_shipping_postcode();
            $country_code          = $order->get_shipping_country();
            $city                  = $order->get_shipping_city();
            $customer_email        = $order->get_billing_email();
            $customer_phone        = $order->get_billing_phone();
            
            $shipping_service      = get_post_meta( $post_id, 'postis_shipping_method', true );
            
            $recipeint = array( 'name'         => $shipping_customerName,
                                'addressLine1' => $shipping_address1,
                                "postcode"     => $shipping_postcode,
                                "countryCode"  => $country_code,
                                "mobilePhone"  => $customer_phone,
                            );
                            
            $recipeint['email'] =  $customer_email;
            $options = array('deliveryServiceId' => $shipping_service);
            $params = array(
        	        'recipient'                => $recipeint,
        	        'options'                  => $options,
        	    );
            
            $order_data = $order->get_data();
            
            $params = array_filter( $params );
        
            // postis_pa($params); exit;
            
            // Set Header
        	$headers = array(
                    'headers'     => array('Content-Type' => 'application/json; charset=utf-8', 'x-api-key'=>$postis_apikey,'domain_name'=> $domain),
                    'body'        => json_encode($params),
                    'method'      => 'POST',
                    'data_format' => 'body',
                );
        		    
            // Run the query
            $response = wp_remote_post( $endpoint_url, $headers );
            $get_shipment_meta = json_decode( $response['body'], true );
            
            
            // postis_pa($get_shipment_meta); exit;
            
            if(  $response['response']['code'] != 400 && $response['response']['code'] != 401 ) {
            
                update_post_meta( $post_id, 'postis_shipment_meta', $get_shipment_meta );
                
                $ajax_response = array('status'=>'success', 'message'=> __('Shipment Created Successfully', 'postis'));
                $res_msg = 'created';
                
            }else{
                $resp_message  = sprintf( __("Shipment Not Created.\nServer Response: %s", "postis"), $get_shipment_meta['message'] );
                $res_msg = 'failed';
                
                if (strpos($get_shipment_meta['message'], 'Ekki var hægt að skrá sendingu (Addressee.Gsm') !== false) {
                    $ajax_response = array('status'=>'error', 'type'=>'phonenumber', 'message'=> $resp_message );
                } else {
                    $ajax_response = array('status'=>'error', 'type'=>'other', 'message'=> $resp_message );
                }
                
            }
            
            $processed_ids[] = $post_id;
        }
    }else if($action === 'print_shipment'){
        foreach ( $post_ids as $post_id ) {
            
            $shipmentId         =  postis_get_shipment_data($post_id, 'shipmentId');
            
            $print_endpoint = postis_get_endpoints( 'print' );
            $print_params = array(
                'shipmentId' => $shipmentId,
                'outputFormat'      => 'poststod'
            );
            $print_params = array_filter( $print_params );
            
            
            // Query format parameters.
            $print_query = add_query_arg( $print_params, $print_endpoint );
            
            // Set Header
        	$print_headers = array(
                    'headers'     => array('x-api-key'=>$postis_apikey, 'domain_name'=> $domain),
                    //'body'        => json_encode($print_params),
                    'method'      => 'POST',
                    // 'data_format' => 'body',
                );
            // postis_pa($print_headers);   
        		    
            // Run the query
            $automatic_printing = postis_get_settings( 'pdf_print' );
            if ($automatic_printing == 'yes') {
                $print_response = wp_remote_post( $print_query, $print_headers );
                
                $print_response_code = wp_remote_retrieve_response_code( $print_response );
                    
                if ($print_response_code == 204 ) {
                    update_post_meta( $post_id, 'postis_is_shipment_printed', 'printed' );
                }else{
                    update_post_meta( $post_id, 'postis_is_shipment_printed', 'not_printed' );
                }
                
                // postis_pa($print_response); exit;
            }
            
        }
    }else{
        return $redirect_to;
    }

    return $redirect_to = add_query_arg( array(
        'processed_count' => count( $processed_ids ),
        'status' => $res_msg,
    ), $redirect_to );
}

if ( is_admin() && ! defined( 'DOING_AJAX' ) ) {

	// adds the coupon filtering dropdown to the orders page
	add_action( 'restrict_manage_posts', 'filter_orders_by_coupon_used' );

	// makes coupons filterable
// 	add_filter( 'posts_join',  'add_order_items_join' );
// 	add_filter( 'posts_where', 'add_filterable_where' );

    add_filter( 'request', 'filter_orders_by_payment_method_query' );	
}

function filter_orders_by_coupon_used() {
	global $typenow;

	if ( 'shop_order' === $typenow ) {

		?>
		<select name="postis_shipment_print_status" id="postis_shipment_print_status">
			<option value=""><?php esc_html_e( 'Shipment Print Status', 'postis' ); ?></option>
			<option value="printed"><?php esc_html_e( 'Printed', 'postis' ); ?></option>
			<option value="not_printed"><?php esc_html_e( 'Not printed', 'postis' ); ?></option>
		</select>
		<?php
	}
}

function filter_orders_by_payment_method_query( $vars ) {
	global $typenow;

	if ( 'shop_order' === $typenow && isset( $_GET['postis_shipment_print_status'] ) && ! empty( $_GET['postis_shipment_print_status'] ) ) {

		$vars['meta_key']   = 'postis_is_shipment_printed';
		$vars['meta_value'] = wc_clean( $_GET['postis_shipment_print_status'] );
	}

	return $vars;
}
